#include "testApp.h"

static bool toggle = false;

//--------------------------------------------------------------
void testApp::setup(){	 
	

	// OUR XML SETTINGS
	loadSettings();
	GUI.useTrueTypeFont("type/courier.ttf", 10);
	//GUI.addSetting(string displayName, string xmlName, float value, float min, float max, float incr){
	GUI.addSetting("camera", 		"CAMERA",	 				0, 			0, 	1,	 		1);
	GUI.addSetting("cv thresh",   	"CV_THRESH",  				30, 		0, 	255, 		1);
	GUI.addSetting("cv min blob", 	"CV_BLOB_MIN", 				30, 		0, 	3000, 		1);
	GUI.addSetting("cv max blob", 	"CV_BLOB_MAX", 				320*240, 	0, 	320*240, 	10);


	// VARIOUS APP SETTINGS
	//set background to black
	ofBackground(0, 0, 0);	
	ofSetVerticalSync(true);	
	ofSetWindowTitle("card");
	ofSetCircleResolution(50);
	//ofSetFullscreen(true);
	
	/*
	//SETUP OUR VIDEO SOURCE
	if(GUI.getSettingI("CAMERA") == 1){
		//videoCV.setupVideo("videos/cardTest.mp4");
		videoCV.setupCamera(0, 320, 240);
	}else{
		//videoCV.setupCamera(0, 320, 240);
		videoCV.setupVideo("videos/CardsWide320.mov");
	}
	videoCV.captureBackgroundFrame();
	videoCV.useTrueTypeFont("type/courier.ttf", 10);
	*/
	whichCard = 0;	
	
}

//--------------------------------------------------------------
void testApp::update(){
	
	/*
	if(GUI.getSettingI("CAMERA") == 1){
		videoCV.useCamera();
	}else{
		videoCV.useVideo();
	}
	*/
	
	//int numFound = videoCV.processFrame(GUI.getSettingI("CV_THRESH"), GUI.getSettingI("CV_BLOB_MIN"), GUI.getSettingI("CV_BLOB_MAX"), whichCard);

	/*if(numFound > 0){
	
	}*/		
}

//--------------------------------------------------------------
void testApp::draw(){
	ofSetupScreen();
	
	ofSetColor(0xFFFFFF);
	GUI.drawText( ofToString(ofGetFrameRate()) , 10, 260);
	//videoCV.draw(0,0);
		
	ofSetColor(0xFFFFFF);
	GUI.drawSelected(700, 270, 200);
	//videoCV.drawStatusMessage(10, 290);
	
	

}


//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	/*
	if( key - 48 >= 1 && key - 48 <= 9 ){
		videoCV.storeCardVal( key - 48 );
		videoCV.setCommonText("stored card "+ ofToString(key - 48));
		//whichCard = key - 48;
	}
	
	if(key == 'f'){
		//ofBeginCustomFullscreen(0,0,2048, 768);
	}else if(key =='w'){
		//ofEndCustomFullscreen();
	}else if(key == 's'){
		saveSettings();
		videoCV.saveCardBank("bank.png");
	}else if(key == 'r'){
		loadSettings();
	}else if(key == OF_KEY_UP){
		GUI.selectPrev();
	}
	else if(key == OF_KEY_DOWN){
		GUI.selectNext();
	}
	else if(key == OF_KEY_RIGHT){
		GUI.increase();
	}
	else if(key == OF_KEY_LEFT){
		GUI.decrease();
	}else if(key == 'c'){
		videoCV.openCameraSettings();

	}else if(key=='g'){
		videoCV.captureBackgroundFrame();
	}else if(key == ' '){
		videoCV.toggleVideoPlayback();
	}
	 */
}

//--------------------------------------------------------------
void testApp::keyReleased (int key){ 
	 whichCard = 0;
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){		
	
}

//---------------------------------------------------------------
void testApp::mouseDragged( int x, int y, int button){
	//videoCV.QUAD.updatePoint(x, y, 0, 0, 320, 240);
}

//---------------------------------------------------------------
void testApp::mousePressed( int x, int y, int button ){
	//videoCV.QUAD.selectPoint(x, y, 0, 0, 320, 240, 30); 
}

//---------------------------------------------------------------
void testApp::mouseReleased(){
	//videoCV.QUAD.releaseAllPoints();
}


//--------------------------------------------------------------
void testApp::loadSettings(){
	GUI.readFromFile(ofToDataPath("settings/settings.xml"));
	GUI.setCommonText("Settings read from file");
}

//--------------------------------------------------------------
void testApp::saveSettings(){
	//videoCV.QUAD.saveToFile("settings/quad.xml");
	GUI.saveToFile(ofToDataPath("settings/settings.xml"));
	GUI.setCommonText("Settings saved to file");
}
