#ifndef _APP_CONSTANTS_H
#define _APP_CONSTANTS_H

#include "ofMain.h"

#define OF_ADDON_USING_OFXVECTORMATH
#define OF_ADDON_USING_OFXOPENCV

#include "ofAddons.h"

typedef struct{

	int id;
	ofxVec2f p;
	ofxVec2f v;
	int pArea;
	int bArea;
	int length;
	float density;
	int birthTime;
	float speed;
}cvData;

typedef struct{
	cvData extra;
	ofxCvBlob blob;
	ofxVec2f left;
	ofxVec2f right;
}dataForTree;



#endif;