#ifndef _CONTOUR_ANALYSER_H
#define _CONTOUR_ANALYSER_H

#include "ofMain.h"
#include "ofAddons.h"

#include "cornerFinder.h"

#define MAX_LEN 1024

class contourAnalyser{

	public:
	
		//---------------------------
		contourAnalyser(){
		}
		
		
		//---------------------------------------------
		ofVec2f * smoothContour(ofCvBlob blob, float smoothAmnt){
		
			blurredPoints[0].x = blob.pts[0].x;
			blurredPoints[0].y = blob.pts[0].y;
									
			for (int j = 1; j < blob.nPts; j++){
				blob.pts[j].x = blob.pts[j].x * (1.0 - smoothAmnt)  + blob.pts[j-1].x * smoothAmnt;
				blob.pts[j].y = blob.pts[j].y * (1.0 - smoothAmnt)  + blob.pts[j-1].y * smoothAmnt;
			
				blurredPoints[j].x = blob.pts[j].x;
				blurredPoints[j].y = blob.pts[j].y;
				
			}
		
			return blurredPoints;
		}
		
		
		ofVec2f blurredPoints[MAX_LEN];
};

#endif